## far2l 2.6.4~beta+ds

=== CMakeLists.txt ===
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/modules)

cmake_minimum_required (VERSION 3.0.2)

project (far2l)

set(APP_NAME "far2l")
set(APP_IDENTIFIER "com.far2l")
set(CPACK_PACKAGE_NAME "far2l")

string(ASCII 27 Esc)
set(ColorNormal "${Esc}[m")
set(ColorRed "${Esc}[1;31m")

include(GNUInstallDirs)

# just to force reconfigure if packaging/version changed
configure_file(${CMAKE_SOURCE_DIR}/packaging/version ${CMAKE_BINARY_DIR}/packaging/version @ONLY)

# reconfigure in case .git directory changed to update version correctly
IF(EXISTS ${CMAKE_SOURCE_DIR}/.git)
    set_property(DIRECTORY APPEND PROPERTY CMAKE_CONFIGURE_DEPENDS ${CMAKE_SOURCE_DIR}/.git)
endif()

file(READ "${CMAKE_SOURCE_DIR}/packaging/version" VERSION)
string(REGEX REPLACE "[\r\n\t ]$" "" VERSION "${VERSION}")
string(REGEX REPLACE "^([0-9]+)\\..*" "\\1" VERSION_MAJOR "${VERSION}")
string(REGEX REPLACE "^[0-9]+\\.([0-9]+).*" "\\1" VERSION_MINOR "${VERSION}")
string(REGEX REPLACE "^[0-9]+\\.[0-9]+\\.(.*)" "\\1" VERSION_PATCH "${VERSION}")

if("${VERSION_MAJOR}" STREQUAL "" OR "${VERSION_MAJOR}" STREQUAL "${VERSION}"
    OR "${VERSION_MINOR}" STREQUAL "" OR "${VERSION_MINOR}" STREQUAL "${VERSION}"
    OR "${VERSION_PATCH}" STREQUAL "" OR "${VERSION_PATCH}" STREQUAL "${VERSION}")
        message(FATAL_ERROR "${ColorRed}packaging/version is corrupted, please write actual X.Y.Z version into it.${ColorNormal}")
endif()

find_package(Git)

if(GIT_FOUND)
    execute_process(COMMAND "${GIT_EXECUTABLE}" describe --tag
        WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
        OUTPUT_VARIABLE GIT_TAG
        OUTPUT_STRIP_TRAILING_WHITESPACE)
endif()

if(NOT "${GIT_TAG}" STREQUAL "v_${VERSION}")
    if(GIT_FOUND)
        if(IS_DIRECTORY ${CMAKE_SOURCE_DIR}/.git)
            execute_process(COMMAND "${GIT_EXECUTABLE}" show --no-patch --format=%ci HEAD
                WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
                OUTPUT_VARIABLE GIT_DATE
                OUTPUT_STRIP_TRAILING_WHITESPACE)
            string(SUBSTRING ${GIT_DATE} 0 10 GIT_DATE)
            execute_process(COMMAND "${GIT_EXECUTABLE}" rev-parse --short HEAD
                WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
                OUTPUT_VARIABLE GIT_HASH
                OUTPUT_STRIP_TRAILING_WHITESPACE)
        endif()
    endif()
    if(NOT "${GIT_DATE}" STREQUAL "")
        message(STATUS "git date: ${GIT_DATE}")
        set(VERSION_PATCH "${VERSION_PATCH}-${GIT_DATE}")
    endif()
    if(NOT "${GIT_HASH}" STREQUAL "")
        message(STATUS "git hash: ${GIT_HASH}")
        set(VERSION_PATCH "${VERSION_PATCH}-${GIT_HASH}")
    else()
        message(WARNING "git information unavailable, assuming its a build from v_${VERSION}")
    endif()
endif()

set(VERSION_PATCH "${VERSION_PATCH}-beta")

set(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")

set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_EXTENSIONS OFF)

if(NOT CMAKE_BUILD_TYPE)
   set(CMAKE_BUILD_TYPE "Release")
endif()

message(STATUS "Build Type: ${CMAKE_BUILD_TYPE} Version: ${VERSION}")

if(NOT DEFINED CMAKE_INSTALL_PREFIX)
   if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
      set(CMAKE_INSTALL_PREFIX "/usr/local")
   elseif (${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
      set(CMAKE_INSTALL_PREFIX "/usr/local")
   else()
      set(CMAKE_INSTALL_PREFIX "/usr")
   endif()
endif()

##############################

if (NOT DEFINED TESTING)
    set(TESTING "NO")
endif()

if (NOT DEFINED USEWX)
    set(USEWX "YES")
endif()

if (NOT DEFINED UNRAR)
    set(UNRAR "bundled")
endif()

# EACP disabled by default for now as FAR's GetCodePageInfo rejects all multibyte charsets due to BUGBUG.
# Uncomment EACP-stuff here when that will be fixed. See https://github.com/elfmz/far2l/issues/1179
#if (NOT DEFINED EACP)
#   set(EACP "YES")
#endif()

if (NOT DEFINED LEGACY)
    # TODO: default it to NO  somewhere in 2022, after all obsolete settings
    # registry-upgrade-to-ini stuff will be safe to remove
    set(LEGACY "YES")
elseif(FARFTP)
    set(LEGACY "YES")
    message(STATUS "Force-enable LEGACY due to enabled FARFTP")
endif()

#if (NOT EACP)
#   message(STATUS "${ColorRed}Building without East Asian codepages support due to EACP=${EACP}${ColorNormal}")
#endif()

# set(RM rm) actually not needed: use $(CMAKE_COMMAND) -E remove

if(MUSL)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D__MUSL__")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D__MUSL__")
endif()

if(TAR_LIMITED_ARGS)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D__TAR_LIMITED_ARGS__")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D__TAR_LIMITED_ARGS__")
endif()

if(${CMAKE_VERSION} VERSION_LESS "3.1.0")
    message("Please consider to switch to newer CMake")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
endif()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -fPIC -Wno-unused-function -D_FILE_OFFSET_BITS=64") #  -fsanitize=address
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -std=c99 -fPIC -Wno-unused-function -D_FILE_OFFSET_BITS=64") #  -fsanitize=address
set(CMAKE_CXX_FLAGS_RELEASE "-O2")
set(CMAKE_C_FLAGS_RELEASE "-O2")

if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    set(APP_DIR ${CMAKE_BINARY_DIR}/install)
    set(INSTALL_DIR ${APP_DIR}/${APP_NAME}.app/Contents/MacOS)
    set(EXECUTABLE_NAME ${APP_NAME})

else()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -ffunction-sections -fdata-sections")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -ffunction-sections -fdata-sections")
    set(INSTALL_DIR ${CMAKE_BINARY_DIR}/install)
    set(EXECUTABLE_NAME far2l)

    if (NOT CMAKE_CXX_COMPILER_ID MATCHES "Clang")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wl,--gc-sections")
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wl,--gc-sections")
    endif()
endif()

if (CMAKE_SYSTEM_NAME MATCHES "CYGWIN")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D_GNU_SOURCE -D_BSD_SOURCE -D_XOPEN_SOURCE=600")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_GNU_SOURCE -D_BSD_SOURCE -D_XOPEN_SOURCE=600")
    message(STATUS "Running under cygwin, wow!")
endif()

if (CMAKE_SYSTEM_NAME MATCHES "Haiku")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D_GNU_SOURCE -D_DEFAULT_SOURCE -Wno-attributes")
endif()

set(CMAKE_CXX_VISIBILITY_PRESET hidden)
set(CMAKE_C_VISIBILITY_PRESET hidden)

if (LEGACY)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DWINPORT_REGISTRY")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DWINPORT_REGISTRY")
    message(STATUS "Enabling registry support due to enabled LEGACY")
else()
    message(STATUS "LEGACY is not enabled, your old registry settings will be forgotten, if any")
endif()

if(CMAKE_VERSION VERSION_GREATER "3.3")
    cmake_policy(SET CMP0063 NEW)
    cmake_policy(SET CMP0057 NEW)
endif()

include_directories(utils/include)

add_subdirectory (WinPort)
add_subdirectory (utils)
add_subdirectory (far2l)

if (NOT ${USEWX})
    message(STATUS "Building without GUI/wxWidgets backend due to USEWX=${USEWX}")
else()
    message(STATUS "Building with GUI/wxWidgets backend")
    if (${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
        if (DEFINED wxWidgets_CONFIG_EXECUTABLE)
            message(STATUS "Using pre-defined wx config: ${wxWidgets_CONFIG_EXECUTABLE}")

        elseif(EXISTS "/usr/local/bin/wxgtk3u-3.2-config")
            set(wxWidgets_CONFIG_EXECUTABLE "/usr/local/bin/wxgtk3u-3.2-config")
            set(wxWidgets_wxrc_EXECUTABLE "/usr/local/bin/wxrc-gtk3u-3.2")
            message(STATUS "Using known location of wx-config 3.2")

        elseif(EXISTS "/usr/local/bin/wxgtk3u-3.1-config")
            set(wxWidgets_CONFIG_EXECUTABLE "/usr/local/bin/wxgtk3u-3.1-config")
            set(wxWidgets_wxrc_EXECUTABLE "/usr/local/bin/wxrc-gtk3u-3.1")
            message(STATUS "Using known location of wx-config 3.1")

        elseif (EXISTS "/usr/local/bin/wxgtk3u-3.0-config")
            set(wxWidgets_CONFIG_EXECUTABLE "/usr/local/bin/wxgtk3u-3.0-config")
            set(wxWidgets_wxrc_EXECUTABLE "/usr/local/bin/wxrc-gtk3u-3.0")
            message(STATUS "Using known location of wx-config 3.0")

        else()
            message(STATUS "No wxgtk3u-3.*-config in expected locations")
        endif()

    elseif (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
        if (EXISTS "/opt/local/Library/Frameworks/wxWidgets.framework/Versions/wxWidgets/3.2/bin/wx-config")
            # MacPorts
            set(wxWidgets_CONFIG_EXECUTABLE "/opt/local/Library/Frameworks/wxWidgets.framework/Versions/wxWidgets/3.2/bin/wx-config")
            set(wxWidgets_wxrc_EXECUTABLE "/opt/local/Library/Frameworks/wxWidgets.framework/Versions/wxWidgets/3.2/bin/wxrc")
            message(STATUS "Using known location of wx-config 3.2")

        elseif (EXISTS "/opt/local/Library/Frameworks/wxWidgets.framework/Versions/wxWidgets/3.1/bin/wx-config")
            # MacPorts
            set(wxWidgets_CONFIG_EXECUTABLE "/opt/local/Library/Frameworks/wxWidgets.framework/Versions/wxWidgets/3.1/bin/wx-config")
            set(wxWidgets_wxrc_EXECUTABLE "/opt/local/Library/Frameworks/wxWidgets.framework/Versions/wxWidgets/3.1/bin/wxrc")
            message(STATUS "Using known location of wx-config 3.1")

        else()
            message(STATUS "No wx-config in expected locations")
        endif()
    endif()

    add_subdirectory(WinPort/src/Backend/WX)
endif()

if (NOT DEFINED TTYX)
    find_package(X11)
    if(X11_FOUND)
        message(STATUS "Building with TTY X11 extensions due to X11 found")
        add_subdirectory(WinPort/src/Backend/TTY/TTYX)
    else()
        message(STATUS "Building without TTY X11 extensions due to X11 not found")
    endif()
elseif (TTYX)
    message(STATUS "Building with TTY X11 extensions due to TTYX=${TTYX}")
    add_subdirectory(WinPort/src/Backend/TTY/TTYX)
else()
    message(STATUS "Building without TTY X11 extensions due to TTYX=${TTYX}")
endif()


##############################
# plugins directives

if (NOT DEFINED ALIGN OR ALIGN)
    message(STATUS "ALIGN plugin enabled")
    add_subdirectory (align)
else()
    message(STATUS "${ColorRed}ALIGN plugin disabled due to ALIGN=${ALIGN}${ColorNormal}")
    install(CODE "
        execute_process(COMMAND ${CMAKE_COMMAND} -E rm -f ${CMAKE_INSTALL_PREFIX}/lib/far2l/Plugins/align/plug/align.far-plug-wide)
        " COMPONENT system)
endif()

if (NOT DEFINED AUTOWRAP OR AUTOWRAP)
    message(STATUS "AUTOWRAP plugin enabled")
    add_subdirectory (autowrap)
else()
    message(STATUS "${ColorRed}AUTOWRAP plugin disabled due to AUTOWRAP=${AUTOWRAP}${ColorNormal}")
    install(CODE "
        execute_process(COMMAND ${CMAKE_COMMAND} -E rm -f ${CMAKE_INSTALL_PREFIX}/lib/far2l/Plugins/autowrap/plug/autowrap.far-plug-wide)
        " COMPONENT system)
endif()

if (NOT DEFINED CALC OR CALC)
    message(STATUS "CALC plugin enabled")
    add_subdirectory (calc)
else()
    message(STATUS "${ColorRed}CALC plugin disabled due to CALC=${CALC}${ColorNormal}")
    install(CODE "
        execute_process(COMMAND ${CMAKE_COMMAND} -E rm -f ${CMAKE_INSTALL_PREFIX}/lib/far2l/Plugins/calc/plug/calc.far-plug-wide)
        " COMPONENT system)
endif()

if (NOT DEFINED COLORER OR COLORER)
    message(STATUS "COLORER plugin enabled")
    add_subdirectory (colorer)
else()
    message(STATUS "${ColorRed}COLORER plugin disabled due to COLORER=${COLORER}${ColorNormal}")
    install(CODE "
        execute_process(COMMAND ${CMAKE_COMMAND} -E rm -f ${CMAKE_INSTALL_PREFIX}/lib/far2l/Plugins/colorer/plug/colorer.far-plug-wide)
        " COMPONENT system)
endif()

if (NOT DEFINED COMPARE OR COMPARE)
    message(STATUS "COMPARE plugin enabled")
    add_subdirectory (compare)
else()
    message(STATUS "${ColorRed}COMPARE plugin disabled due to COMPARE=${COMPARE}${ColorNormal}")
    install(CODE "
        execute_process(COMMAND ${CMAKE_COMMAND} -E rm -f ${CMAKE_INSTALL_PREFIX}/lib/far2l/Plugins/compare/plug/compare.far-plug-wide)
        " COMPONENT system)
endif()

if (NOT DEFINED DRAWLINE OR DRAWLINE)
    message(STATUS "DRAWLINE plugin enabled")
    add_subdirectory (drawline)
else()

=== far2l/CMakeLists.txt ===
project(far2l)

add_subdirectory (bootstrap)

set(SOURCES
src/farversion.cpp
src/cache.cpp
src/clipboard.cpp
src/cmdline.cpp
src/copy.cpp
src/ctrlobj.cpp
src/datetime.cpp
src/delete.cpp
src/dialog.cpp
src/dirinfo.cpp
src/dizlist.cpp
src/DialogBuilder.cpp
src/dlgedit.cpp
src/DlgGuid.cpp
src/edit.cpp
src/editor.cpp
src/EditorConfigOrg.cpp
src/execute.cpp
src/farwinapi.cpp
src/fileattr.cpp
src/fileedit.cpp
src/filefilter.cpp
src/filefilterparams.cpp
src/FilesSuggestor.cpp
src/fileowner.cpp
src/filepanels.cpp
src/filestr.cpp
src/filetype.cpp
src/fileview.cpp
src/findfile.cpp
src/FindPattern.cpp
src/flink.cpp
src/fnparce.cpp
src/foldtree.cpp
src/frame.cpp
src/global.cpp
src/help.cpp
src/hilight.cpp
src/hmenu.cpp
src/Mounts.cpp
src/keybar.cpp
src/main.cpp
src/manager.cpp
src/menubar.cpp
src/message.cpp
src/mkdir.cpp
src/modal.cpp
src/namelist.cpp
src/options.cpp
src/plist.cpp
src/rdrwdsk.cpp
src/RefreshFrameManager.cpp
src/scantree.cpp
src/setattr.cpp
src/setcolor.cpp
src/pick_color.cpp
src/pick_color256.cpp
src/pick_colorRGB.cpp
src/stddlg.cpp
src/synchro.cpp
src/syslog.cpp
src/TPreRedrawFunc.cpp
src/usermenu.cpp
src/viewer.cpp
src/vmenu.cpp
src/execute_oscmd.cpp
src/ViewerStrings.cpp
src/ViewerPrinter.cpp
src/fileholder.cpp
src/GrepFile.cpp
src/about.cpp

src/panels/panel.cpp
src/panels/filelist.cpp
src/panels/fldata.cpp
src/panels/flmodes.cpp
src/panels/flplugin.cpp
src/panels/flshow.cpp
src/panels/flupdate.cpp
src/panels/infolist.cpp
src/panels/qview.cpp
src/panels/treelist.cpp

src/console/AnsiEsc.cpp
src/console/keyboard.cpp
src/console/console.cpp
src/console/constitle.cpp
src/console/interf.cpp
src/console/grabber.cpp
src/console/lockscrn.cpp
src/console/palette.cpp
src/console/savescr.cpp
src/console/scrbuf.cpp
src/console/scrobj.cpp
src/console/scrsaver.cpp

src/filemask/CFileMask.cpp
src/filemask/FileMasksProcessor.cpp
src/filemask/FileMasksWithExclude.cpp

src/locale/codepage.cpp
src/locale/DetectCodepage.cpp
src/locale/xlat.cpp
src/locale/locale.cpp

src/bookmarks/Bookmarks.cpp
src/bookmarks/BookmarksMenu.cpp
src/bookmarks/BookmarksLegacy.cpp

src/cfg/AllXLats.cpp
src/cfg/config.cpp
src/cfg/ConfigOpt.cpp
src/cfg/ConfigOptEdit.cpp
src/cfg/ConfigRW.cpp
src/cfg/ConfigLegacy.cpp
src/cfg/HotkeyLetterDialog.cpp
src/cfg/language.cpp

src/hist/history.cpp
src/hist/poscache.cpp

src/plug/plugapi.cpp
src/plug/plugins.cpp
src/plug/PluginW.cpp
src/plug/PluginA.cpp
src/plug/plclass.cpp

src/vt/vtansi.cpp
src/vt/vtshell.cpp
src/vt/vtshell_translation.cpp
src/vt/vtshell_translation_kitty.cpp
src/vt/vtshell_compose.cpp
src/vt/vtshell_leader.cpp
src/vt/vtshell_ioreaders.cpp
src/vt/vtshell_mouse.cpp
src/vt/vtlog.cpp
src/vt/vtcompletor.cpp
src/vt/VTFar2lExtensios.cpp

src/base/InterThreadCall.cpp
src/base/SafeMMap.cpp
src/base/farqueue.cpp
src/base/FARString.cpp
src/base/farrtl.cpp
src/base/DList.cpp

src/mix/format.cpp
src/mix/udlist.cpp
src/mix/cvtname.cpp
src/mix/cddrv.cpp
src/mix/chgprior.cpp
src/mix/MountInfo.cpp
src/mix/dirmix.cpp
src/mix/drivemix.cpp
src/mix/mix.cpp
src/mix/panelmix.cpp
src/mix/pathmix.cpp
src/mix/processname.cpp
src/mix/RegExp.cpp
src/mix/strmix.cpp
src/mix/FSFileFlags.cpp
src/mix/StrCells.cpp
src/mix/ChunkedData.cpp
src/mix/UsedChars.cpp
src/mix/CachedCreds.cpp
)

# Option to disable building macro subsystem completely
option(FAR2MACRO "Use Far 2 macro engine" ON)

# Option to keep TVar implementation even if Far2 marco subsystem is not used
# (as it may be needed by alternative macro subsystem implementations)
option(FAR2TVAR  "Use Far 2 TVar" ON)

if(FAR2MACRO)
    list(APPEND SOURCES src/macro/chgmmode.cpp)
    list(APPEND SOURCES src/macro/macro.cpp)
    list(APPEND SOURCES src/macro/syntax.cpp)
    list(APPEND SOURCES src/macro/tvar.cpp)
else()
    if(FAR2TVAR)
        list(APPEND SOURCES src/macro/tvar.cpp)
        add_compile_definitions(FAR2TVAR)
    endif()
    list(APPEND SOURCES src/macro/nomacro.cpp)
endif()

# Set target names for the executables
if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    set(MACOSX_BUNDLE_LONG_VERSION_STRING ${VERSION})
    set(MACOSX_BUNDLE_SHORT_VERSION_STRING ${VERSION})
    set(MACOSX_BUNDLE_GUI_IDENTIFIER ${APP_IDENTIFIER})
    set(MACOSX_BUNDLE_ICON_FILE "Far.icns")
    set(MACOSX_BUNDLE_BUNDLE_NAME ${APP_NAME})
    add_executable(far2l MACOSX_BUNDLE ${SOURCES} "DE/Far.icns")
    set_target_properties(far2l PROPERTIES
        OUTPUT_NAME ${APP_NAME}
        RUNTIME_OUTPUT_DIRECTORY ${APP_DIR})
    set_source_files_properties("DE/Far.icns" PROPERTIES
        MACOSX_PACKAGE_LOCATION Resources)
else()
    add_executable(far2l ${SOURCES})
    set_target_properties(far2l PROPERTIES
        RUNTIME_OUTPUT_DIRECTORY "${INSTALL_DIR}")
endif()

if (NOT DEFINED USEUCD)
    set(USEUCD "YES")
endif()

if (NOT USEUCD)
    message(STATUS "Building without libuchardet due to USEUCD=${USEUCD}")
else()
    message(STATUS "Building with libuchardet")
    find_package(Uchardet REQUIRED)
    target_compile_definitions(far2l PRIVATE -DUSEUCD)
endif()

target_compile_definitions(far2l PRIVATE -DUNICODE)

target_include_directories(far2l PRIVATE
    .
    far2sdk
    src
    src/base
    src/mix
    src/bookmarks
    src/cfg
    src/console
    src/panels
    src/filemask
    src/hist
    src/locale
    src/macro
    src/plug
    src/vt
    ${CMAKE_CURRENT_BINARY_DIR}
    ${UCHARDET_INCLUDE_DIRS}
    ../WinPort)

add_dependencies(far2l bootstrap WinPort)

if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    SET (WINPORT -force_load WinPort wineguts utils)
else()
    SET (WINPORT -Wl,--whole-archive WinPort -Wl,--no-whole-archive)
endif()

set_target_properties(far2l
    PROPERTIES
    ENABLE_EXPORTS TRUE)

if (${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
    target_link_libraries(far2l
    PRIVATE ${WINPORT}
    PRIVATE c
    PRIVATE ${UCHARDET_LIBRARIES})
elseif(${CMAKE_SYSTEM_NAME} MATCHES "Haiku")
    target_link_libraries(far2l
        PRIVATE ${WINPORT}
        PRIVATE gnu
        PRIVATE ${UCHARDET_LIBRARIES})
else()
    target_link_libraries(far2l
    PRIVATE ${WINPORT}
        PRIVATE dl
        PRIVATE ${UCHARDET_LIBRARIES})
endif()

add_custom_command(TARGET far2l POST_BUILD
    COMMAND ln -sf ${EXECUTABLE_NAME} ${INSTALL_DIR}/far2l_askpass
    COMMAND ln -sf ${EXECUTABLE_NAME} ${INSTALL_DIR}/far2l_sudoapp
    COMMAND ln -sf ${EXECUTABLE_NAME} ${INSTALL_DIR}/far2ledit)

if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
#TODO
else()
    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/DE/far2l.desktop" "${CMAKE_CURRENT_BINARY_DIR}/DE/far2l.desktop")
    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/DE/far2ledit.desktop" "${CMAKE_CURRENT_BINARY_DIR}/DE/far2ledit.desktop")

    install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/DE/icons" DESTINATION "share" USE_SOURCE_PERMISSIONS COMPONENT desktop FILES_MATCHING PATTERN "*")

	# Have to make desktop files executable, see:
	# https://wiki.ubuntu.com/SecurityTeam/Policies#Execute-Permission_Bit_Required
    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/DE/far2l.desktop" "${CMAKE_CURRENT_BINARY_DIR}/DE/far2ledit.desktop"
        DESTINATION "share/applications"
        COMPONENT desktop
        PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_READ WORLD_EXECUTE)
endif()

=== multiarc/CMakeLists.txt ===

project(multiarc)

set(SOURCES
    src/MultiArc.cpp
    src/ArcPlg.cpp
    src/arccfg.cpp
    src/arcget.cpp
    src/arcput.cpp
    src/ArcMix.cpp
    src/ArcProc.cpp
    src/global.cpp
    src/arcread.cpp
    src/arccmd.cpp
    src/formats/ha/ha.cpp
    src/formats/arj/arj.cpp
    src/formats/ace/ace.cpp
    src/formats/arc/arc.cpp
    src/formats/zip/zip.cpp
    src/formats/lzh/lzh.cpp

        src/formats/7z/C/7zAlloc.c
        src/formats/7z/C/7zArcIn.c
        src/formats/7z/C/7zBuf2.c
        src/formats/7z/C/7zBuf.c
        src/formats/7z/C/7zCrc.c
        src/formats/7z/C/7zCrcOpt.c
        src/formats/7z/C/7zDec.c
        src/formats/7z/C/7zFile.c
        src/formats/7z/C/7zStream.c
        src/formats/7z/C/Aes.c
        src/formats/7z/C/AesOpt.c
        src/formats/7z/C/Alloc.c
        src/formats/7z/C/Bcj2.c
        src/formats/7z/C/Bcj2Enc.c
        src/formats/7z/C/Blake2s.c
        src/formats/7z/C/Bra86.c
        src/formats/7z/C/Bra.c
        src/formats/7z/C/BraIA64.c
        src/formats/7z/C/BwtSort.c
        src/formats/7z/C/CpuArch.c
        src/formats/7z/C/Delta.c
        src/formats/7z/C/DllSecur.c
        src/formats/7z/C/HuffEnc.c
        src/formats/7z/C/LzFind.c
        src/formats/7z/C/LzFindMt.c
        src/formats/7z/C/LzFindOpt.c
        src/formats/7z/C/Lzma2Dec.c
        src/formats/7z/C/Lzma2DecMt.c
        src/formats/7z/C/Lzma2Enc.c
        src/formats/7z/C/Lzma86Dec.c
        src/formats/7z/C/Lzma86Enc.c
        src/formats/7z/C/LzmaDec.c
        src/formats/7z/C/LzmaEnc.c
        src/formats/7z/C/LzmaLib.c
        src/formats/7z/C/MtCoder.c
        src/formats/7z/C/MtDec.c
        src/formats/7z/C/Ppmd7aDec.c
        src/formats/7z/C/Ppmd7.c
        src/formats/7z/C/Ppmd7Dec.c
        src/formats/7z/C/Ppmd7Enc.c
        src/formats/7z/C/Ppmd8.c
        src/formats/7z/C/Ppmd8Dec.c
        src/formats/7z/C/Ppmd8Enc.c
        src/formats/7z/C/Sha1.c
        src/formats/7z/C/Sha1Opt.c
        src/formats/7z/C/Sha256.c
        src/formats/7z/C/Sha256Opt.c
        src/formats/7z/C/Sort.c
        src/formats/7z/C/SwapBytes.c
        src/formats/7z/C/Threads.c
        src/formats/7z/C/Xxh64.c
        src/formats/7z/C/Xz.c
        src/formats/7z/C/XzCrc64.c
        src/formats/7z/C/XzCrc64Opt.c
        src/formats/7z/C/XzDec.c
        src/formats/7z/C/XzEnc.c
        src/formats/7z/C/XzIn.c
        src/formats/7z/C/ZstdDec.c
        src/formats/7z/7z.cpp
        src/formats/7z/7zMain.cpp

        src/formats/ha/ha/acoder.c
        src/formats/ha/ha/archive.c
        src/formats/ha/ha/asc.c
        src/formats/ha/ha/cpy.c
        src/formats/ha/ha/error.c
        src/formats/ha/ha/ha.c
        src/formats/ha/ha/haio.c
        src/formats/ha/ha/hsc.c
        src/formats/ha/ha/info.c
        src/formats/ha/ha/machine.c
        src/formats/ha/ha/misc.c
        src/formats/ha/ha/swdict.c
)

if("${UNRAR}" STREQUAL "lib")
    set(SOURCES
        ${SOURCES}
        src/formats/rar/rar.cpp
        src/formats/rar/rarmainstub.cpp
    )
elseif(UNRAR)
    set(SOURCES
        ${SOURCES}
        src/formats/rar/rar.cpp
        src/formats/rar/unrar/scantree.cpp
        src/formats/rar/unrar/sha1.cpp
        src/formats/rar/unrar/threadpool.cpp
        src/formats/rar/unrar/crc.cpp
        src/formats/rar/unrar/hash.cpp
        src/formats/rar/unrar/strlist.cpp
        src/formats/rar/unrar/rs16.cpp
        src/formats/rar/unrar/resource.cpp
        src/formats/rar/unrar/consio.cpp
        src/formats/rar/unrar/secpassword.cpp
        src/formats/rar/unrar/qopen.cpp
        src/formats/rar/unrar/recvol.cpp
        src/formats/rar/unrar/rijndael.cpp
        src/formats/rar/unrar/timefn.cpp
        src/formats/rar/unrar/encname.cpp
        src/formats/rar/unrar/rawread.cpp
        src/formats/rar/unrar/file.cpp
        src/formats/rar/unrar/strfn.cpp
        src/formats/rar/unrar/sha256.cpp
        src/formats/rar/unrar/filefn.cpp
        src/formats/rar/unrar/filcreat.cpp
        src/formats/rar/unrar/headers.cpp
        src/formats/rar/unrar/blake2s.cpp
        src/formats/rar/unrar/options.cpp
        src/formats/rar/unrar/volume.cpp
        src/formats/rar/unrar/system.cpp
        src/formats/rar/unrar/crypt.cpp
        src/formats/rar/unrar/cmddata.cpp
        src/formats/rar/unrar/extinfo.cpp
        src/formats/rar/unrar/filestr.cpp
        src/formats/rar/unrar/ui.cpp
        src/formats/rar/unrar/list.cpp
        src/formats/rar/unrar/find.cpp
        src/formats/rar/unrar/smallfn.cpp
        src/formats/rar/unrar/unicode.cpp
        src/formats/rar/unrar/pathfn.cpp
        src/formats/rar/unrar/global.cpp
        src/formats/rar/unrar/rarvm.cpp
        src/formats/rar/unrar/getbits.cpp
        src/formats/rar/unrar/rs.cpp
        src/formats/rar/unrar/errhnd.cpp
        src/formats/rar/unrar/archive.cpp
        src/formats/rar/unrar/dll.cpp
        src/formats/rar/unrar/extract.cpp
        src/formats/rar/unrar/match.cpp
        src/formats/rar/unrar/unpack.cpp
        src/formats/rar/unrar/arcread.cpp
        src/formats/rar/unrar/rdwrfn.cpp
        src/formats/rar/unrar/rarpch.cpp
        src/formats/rar/unrar/rar.cpp
    )
endif()

set(SOURCES
    ${SOURCES}
    src/formats/custom/custom.cpp
)

if(LibArchive_FOUND)
    set(SOURCES
        ${SOURCES}
        src/formats/libarch/libarch_utils.cpp
        src/formats/libarch/libarch_crutches.cpp
        src/formats/libarch/libarch_cmd_read.cpp
        src/formats/libarch/libarch_cmd_write.cpp
        src/formats/libarch/libarch.cpp
    )
else()
    set(SOURCES
        ${SOURCES}
        src/formats/targz/targz.cpp
        src/formats/cab/cab.cpp

    )
endif()

add_library (multiarc MODULE ${SOURCES})

target_compile_definitions(multiarc PRIVATE -D_7ZIP_ST -D_7ZIP_PPMD_SUPPPORT)

target_link_libraries(multiarc utils far2l)

if(NOT UNRAR)
    if (LibArchive_FOUND)
        message(STATUS "Using LibArchive for limited RAR archives support.")
    else()
        message(STATUS "${ColorRed}RAR archives support disabled due to UNRAR=${UNRAR} and lack of LibArchive.${ColorNormal}")
    endif()

elseif("${UNRAR}" STREQUAL "lib")
    message(STATUS "Using system unrar - will need libunrar and unrar tool.")
    find_package(Unrar REQUIRED)
    target_include_directories(multiarc PRIVATE ${UNRAR_INCLUDE_DIR})
    target_compile_definitions(multiarc PRIVATE -DRARDLL -DHAVE_UNRAR)
    target_link_libraries(multiarc ${UNRAR_LIBRARIES})
else()
    message(STATUS "Using bundled unrar sources")
    target_include_directories(multiarc PRIVATE src/formats/rar/unrar)
    target_compile_definitions(multiarc PRIVATE -DRARDLL -DHAVE_UNRAR)
endif()

target_include_directories(multiarc PRIVATE src)
target_include_directories(multiarc PRIVATE src/libpcre)
target_include_directories(multiarc PRIVATE ../WinPort)
target_include_directories(multiarc PRIVATE ../far2l/far2sdk)

if(PCRE_FOUND)
    target_compile_definitions(multiarc PRIVATE -DHAVE_PCRE)
    target_link_libraries(multiarc ${PCRE_LDFLAGS} ${PCRE_LIBRARIES})
    target_include_directories(multiarc PRIVATE ${PCRE_INCLUDE_DIRS})
endif()

if(LibArchive_FOUND)
    target_compile_definitions(multiarc PRIVATE -DHAVE_LIBARCHIVE)
    target_link_libraries(multiarc ${LibArchive_LIBRARIES})
    target_include_directories(multiarc PRIVATE ${LibArchive_INCLUDE_DIRS})
endif()

set_target_properties(multiarc
    PROPERTIES
        LIBRARY_OUTPUT_DIRECTORY "${INSTALL_DIR}/Plugins/multiarc/plug"
        PREFIX ""
        SUFFIX ".far-plug-mb")

add_custom_command(TARGET multiarc POST_BUILD
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/configs
    COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_CURRENT_SOURCE_DIR}/configs "${INSTALL_DIR}/Plugins/multiarc")

=== packaging/CMakeLists.txt ===
string(TOLOWER ${PROJECT_NAME} CPACK_PACKAGE_NAME)
IF (NOT ${USEWX})
    SET(CPACK_PACKAGE_NAME "${CPACK_PACKAGE_NAME}-nowx")
ENDIF()
set(CPACK_PACKAGE_VENDOR "elfmz")
set(CPACK_PACKAGE_CONTACT "https://github.com/elfmz")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Multi-platform fork of FAR v2")
SET(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_SOURCE_DIR}/README.md")
SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/LICENSE.txt")
set(CPACK_PACKAGE_VERSION_MAJOR ${VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${VERSION_PATCH})
SET(CPACK_PACKAGE_INSTALL_DIRECTORY ${CPACK_PACKAGE_NAME})
set(CPACK_PACKAGE_FILE_NAME ${CPACK_PACKAGE_NAME}-${VERSION})

LIST(APPEND PACKAGE_DEPENDENCIES libc6)
LIST(APPEND PACKAGE_DEPENDENCIES libglib2.0-0 libstdc++6)
LIST(APPEND PACKAGE_DEPENDENCIES "libgcc-s1 | libgcc | libgcc1")
LIST(APPEND PACKAGE_DEPENDENCIES libminizip1 libpcre2-8-0)
# from main project
IF (${USEWX})
    find_package(wxWidgets REQUIRED core base)
    IF (${wxWidgets_VERSION_STRING} EQUAL "3.2.1")
        LIST(APPEND PACKAGE_DEPENDENCIES "libwxgtk3.2-1, libwxbase3.2-1")
    ELSE()
        LIST(APPEND PACKAGE_DEPENDENCIES libwxgtk3.0-gtk3-0v5)
    ENDIF()
ENDIF()
if(OPENSSL_FOUND)
    LIST(APPEND PACKAGE_DEPENDENCIES "libssl1.1 | libssl3")
endif(OPENSSL_FOUND)
if(LIBSSH_FOUND)
    LIST(APPEND PACKAGE_DEPENDENCIES libssh-4)
endif(LIBSSH_FOUND)
if(LIBSMBCLIENT_FOUND)
    LIST(APPEND PACKAGE_DEPENDENCIES libsmbclient)
endif(LIBSMBCLIENT_FOUND)
if(LIBNFS_FOUND)
    LIST(APPEND PACKAGE_DEPENDENCIES "libnfs11 | libnfs12 | libnfs13 | libnfs14")
endif(LIBNFS_FOUND)
if(LIBNEON_FOUND)
    LIST(APPEND PACKAGE_DEPENDENCIES libneon27)
endif(LIBNEON_FOUND)
if(PCRE_FOUND)
    LIST(APPEND PACKAGE_DEPENDENCIES libpcre2-8-0)
endif(PCRE_FOUND)
if(LibArchive_FOUND)
    LIST(APPEND PACKAGE_DEPENDENCIES libarchive13)
endif(LibArchive_FOUND)
IF (${PYTHON})
    LIST(APPEND PACKAGE_DEPENDENCIES "python3, python3-cffi")
ENDIF()

string(REPLACE ";" ", " PACKAGE_DEPENDENCIES "${PACKAGE_DEPENDENCIES}")

FIND_PROGRAM(DPKG_CMD dpkg)
IF(DPKG_CMD)
    LIST(APPEND CPACK_GENERATOR DEB)
ELSE(DPKG_CMD)
    MESSAGE( STATUS "dpkg binary not found, not building debian package" )
ENDIF(DPKG_CMD)

# CPack components:
# -- app, base, system (main project);
# -- desktop (far2l subproject).
#
SET(CPACK_COMPONENTS_GROUPING ALL_COMPONENTS_IN_ONE)
if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    set(CPACK_COMPONENTS_ALL app)
    set(CPACK_GENERATOR DragNDrop)
    set(CPACK_DMG_VOLUME_NAME ${CPACK_PACKAGE_NAME}-${VERSION})
    set(CPACK_DMG_DS_STORE_SETUP_SCRIPT ${CMAKE_BINARY_DIR}/packaging/osx/Setup.scpt)
    set(CPACK_DMG_BACKGROUND_IMAGE ${PROJECT_SOURCE_DIR}/packaging/osx/Background.png)
    set(CPACK_PACKAGE_ICON ${PROJECT_SOURCE_DIR}/far2l/DE/Far.icns)

    configure_file(${PROJECT_SOURCE_DIR}/packaging/osx/Setup.scpt.in ${CMAKE_BINARY_DIR}/packaging/osx/Setup.scpt)
else ()
    set(CPACK_COMPONENTS_ALL base desktop system)
    SET(CPACK_PACKAGING_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})

    LIST(FIND CPACK_GENERATOR DEB DEB_GENERATOR_PRESENCE)
    IF(DEB_GENERATOR_PRESENCE GREATER -1) # linux (deb)
        set(CPACK_DEB_COMPONENT_INSTALL ON)
        # add DEB-package controls to build process
        ADD_SUBDIRECTORY(debian)
        set(CPACK_DEBIAN_BASE_PACKAGE_NAME ${CPACK_PACKAGE_NAME})
        set(CPACK_DEBIAN_FILE_NAME DEB-DEFAULT)
        SET(CPACK_DEBIAN_PACKAGE_MAINTAINER ${CPACK_PACKAGE_VENDOR})
        SET(CPACK_DEBIAN_PACKAGE_SECTION contrib/utils)
        SET(CPACK_DEBIAN_PACKAGE_PRIORITY optional)
        SET(CPACK_DEBIAN_PACKAGE_DEPENDS ${PACKAGE_DEPENDENCIES})
    ENDIF(DEB_GENERATOR_PRESENCE GREATER -1)

    LIST(APPEND CPACK_GENERATOR TGZ)
    set(CPACK_ARCHIVE_COMPONENT_INSTALL ON)
    set(CPACK_ARCHIVE_BASE_FILE_NAME ${CPACK_PACKAGE_FILE_NAME})
endif ()

include(CPack)

=== colorer/src/Colorer-library/src/CMakeLists.txt ===
#====================================================
# colorer source
#====================================================
set(SRC_COLORER
    colorer/Common.h
    colorer/Exception.h
    colorer/FileType.h
    colorer/HrcLibrary.h
    colorer/LineSource.h
    colorer/ParserFactory.h
    colorer/Region.h
    colorer/RegionHandler.h
    colorer/Scheme.h
    colorer/TextParser.h
    colorer/base/BaseNames.h
    colorer/base/XmlTagDefs.h
    colorer/common/Exception.cpp
    colorer/common/Logger.cpp
    colorer/common/Logger.h
    colorer/cregexp/cregexp.cpp
    colorer/cregexp/cregexp.h
    colorer/editor/BaseEditor.cpp
    colorer/editor/BaseEditor.h
    colorer/editor/EditorListener.h
    colorer/editor/OutlineItem.h
    colorer/editor/Outliner.cpp
    colorer/editor/Outliner.h
    colorer/editor/PairMatch.h
    colorer/handlers/LineRegion.cpp
    colorer/handlers/LineRegion.h
    colorer/handlers/LineRegionsCompactSupport.cpp
    colorer/handlers/LineRegionsCompactSupport.h
    colorer/handlers/LineRegionsSupport.cpp
    colorer/handlers/LineRegionsSupport.h
    colorer/handlers/RegionDefine.h
    colorer/handlers/RegionMapper.cpp
    colorer/handlers/RegionMapper.h
    colorer/handlers/StyledHRDMapper.cpp
    colorer/handlers/StyledHRDMapper.h
    colorer/handlers/StyledRegion.cpp
    colorer/handlers/StyledRegion.h
    colorer/handlers/TextHRDMapper.cpp
    colorer/handlers/TextHRDMapper.h
    colorer/handlers/TextRegion.cpp
    colorer/handlers/TextRegion.h
    colorer/io/FileInputSource.cpp
    colorer/io/FileInputSource.h
    colorer/io/FileWriter.cpp
    colorer/io/FileWriter.h
    colorer/io/InputSource.cpp
    colorer/io/InputSource.h
    colorer/io/StreamWriter.cpp
    colorer/io/StreamWriter.h
    colorer/io/Writer.cpp
    colorer/io/Writer.h
    colorer/parsers/CatalogParser.cpp
    colorer/parsers/CatalogParser.h
    colorer/parsers/FileType.cpp
    colorer/parsers/FileTypeChooser.cpp
    colorer/parsers/FileTypeChooser.h
    colorer/parsers/FileTypeImpl.cpp
    colorer/parsers/FileTypeImpl.h
    colorer/parsers/HrcLibrary.cpp
    colorer/parsers/HrcLibraryImpl.cpp
    colorer/parsers/HrcLibraryImpl.h
    colorer/parsers/HrdNode.h
    colorer/parsers/KeywordList.cpp
    colorer/parsers/KeywordList.h
    colorer/parsers/ParserFactory.cpp
    colorer/parsers/ParserFactoryImpl.cpp
    colorer/parsers/ParserFactoryImpl.h
    colorer/parsers/SchemeImpl.h
    colorer/parsers/SchemeNode.cpp
    colorer/parsers/SchemeNode.h
    colorer/parsers/TextParser.cpp
    colorer/parsers/TextParserHelpers.cpp
    colorer/parsers/TextParserHelpers.h
    colorer/parsers/TextParserImpl.cpp
    colorer/parsers/TextParserImpl.h
    colorer/parsers/VirtualEntry.h
    colorer/utils/Environment.cpp
    colorer/utils/Environment.h
    colorer/version.h
    colorer/viewer/ParsedLineWriter.cpp
    colorer/viewer/ParsedLineWriter.h
    colorer/viewer/TextConsoleViewer.cpp
    colorer/viewer/TextConsoleViewer.h
    colorer/viewer/TextLinesStore.cpp
    colorer/viewer/TextLinesStore.h
    colorer/xml/XMLNode.cpp
    colorer/xml/XMLNode.h
    colorer/xml/XmlInputSource.cpp
    colorer/xml/XmlInputSource.h
    colorer/xml/XmlReader.cpp
    colorer/xml/XmlReader.h
)


set(SRC_COLORER_XML
  colorer/xml/libxml2/LibXmlReader.cpp
  colorer/xml/libxml2/LibXmlReader.h
  colorer/xml/libxml2/LibXmlInputSource.h
  colorer/xml/libxml2/LibXmlInputSource.cpp
)


if(COLORER_USE_ZIPINPUTSOURCE)
  set(COLORER_FEATURE_ZIPINPUTSOURCE 1)
  set(SRC_COLORER_ZIP
    colorer/xml/libxml2/SharedXmlInputSource.cpp
    colorer/xml/libxml2/SharedXmlInputSource.h
    colorer/zip/MemoryFile.cpp
    colorer/zip/MemoryFile.h
  )
endif()

if(COLORER_USE_ICU_STRINGS)
  set(SRC_COLORER_STRINGS
      colorer/strings/icu/common_icu.h
      colorer/strings/icu/strings.h
      colorer/strings/icu/Character.cpp
      colorer/strings/icu/Character.h
      colorer/strings/icu/Encodings.cpp
      colorer/strings/icu/Encodings.h
      colorer/strings/icu/UnicodeStringContainer.h
      colorer/strings/icu/UnicodeTools.cpp
      colorer/strings/icu/UnicodeTools.h
      colorer/strings/icu/UStr.cpp
      colorer/strings/icu/UStr.h
  )
  set(COLORER_FEATURE_ICU 1)

else()
  set(SRC_COLORER_STRINGS
      colorer/strings/legacy/common_legacy.h
      colorer/strings/legacy/strings.h
      colorer/strings/legacy/BitArray.cpp
      colorer/strings/legacy/BitArray.h
      colorer/strings/legacy/Character.cpp
      colorer/strings/legacy/Character.h
      colorer/strings/legacy/CharacterClass.cpp
      colorer/strings/legacy/CharacterClass.h
      colorer/strings/legacy/CommonString.h
      colorer/strings/legacy/CString.cpp
      colorer/strings/legacy/CString.h
      colorer/strings/legacy/Encodings.cpp
      colorer/strings/legacy/Encodings.h
      colorer/strings/legacy/UnicodeString.cpp
      colorer/strings/legacy/UnicodeString.h
      colorer/strings/legacy/UnicodeStringContainer.h
      colorer/strings/legacy/UnicodeTools.cpp
      colorer/strings/legacy/UnicodeTools.h
      colorer/strings/legacy/UStr.cpp
      colorer/strings/legacy/UStr.h
      colorer/strings/legacy/x_charcategory.h
      colorer/strings/legacy/x_charcategory2.h
      colorer/strings/legacy/x_charcategory_names.h
      colorer/strings/legacy/x_defines.h
      colorer/strings/legacy/x_encodings.h
      colorer/strings/legacy/x_tables.h
      colorer/strings/legacy/StringExceptions.h
  )
endif()

if(COLORER_BUILD_OLD_COMPILERS)
  set(SRC_COLORER_PLATFORM colorer/platform/filesystem.hpp)
  set(COLORER_FEATURE_OLD_COMPILERS 1)
endif()

#====================================================
# Generate headers
#====================================================
configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/colorer/common/Features.h.in
    ${CMAKE_CURRENT_BINARY_DIR}/colorer/common/Features.h
)

#====================================================
# common flags
#====================================================
if(CMAKE_CXX_COMPILER_ID MATCHES "GNU" OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  # default for gcc
  # CMAKE_CXX_FLAGS=
  # CMAKE_CXX_FLAGS_DEBUG= -g
  # CMAKE_CXX_FLAGS_RELEASE= -O3 -DNDEBUG

  # set only new flags
  set(FLAGS_CXX_DEFAULT -fpermissive -Wall -Wextra -Wpedantic -Wsign-promo -Wnon-virtual-dtor)

  if (COLORER_BUILD_HARD_WARNINGS)
    set(FLAGS_CXX_RELEASE ${FLAGS_CXX_RELEASE} -Werror)
  endif()

  set(FLAGS_CXX_DEBUG)
elseif(CMAKE_CXX_COMPILER_ID MATCHES "MSVC")

  # default for msvc
  # CMAKE_CXX_FLAGS= /DWIN32 /D_WINDOWS /GR /EHsc
  # CMAKE_CXX_FLAGS_DEBUG= /MDd /Zi /Ob0 /Od /RTC1
  # CMAKE_CXX_FLAGS_RELEASE= /MD /O2 /Ob2 /DNDEBUG

  # remove /W3 flag from CMAKE_CXX_FLAGS
  string(REGEX REPLACE "/W[3|4]" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")

  set(FLAGS_CXX_DEFAULT)
  set(FLAGS_CXX_RELEASE /W3)

  if (COLORER_BUILD_HARD_WARNINGS)
    set(FLAGS_CXX_RELEASE ${FLAGS_CXX_RELEASE} /WX)
  endif()

  set(FLAGS_CXX_DEBUG /W4)
endif()

set(MAIN_FLAGS_CXX_DEBUG ${FLAGS_CXX_DEBUG} ${FLAGS_CXX_DEFAULT})
set(MAIN_FLAGS_CXX_RELEASE ${FLAGS_CXX_RELEASE} ${FLAGS_CXX_DEFAULT})

#====================================================
# build
#====================================================
add_library(colorer_lib STATIC ${SRC_COLORER} ${SRC_COLORER_STRINGS} ${SRC_COLORER_XML} ${SRC_COLORER_ZIP} ${SRC_COLORER_PLATFORM})
add_library(colorer::colorer ALIAS colorer_lib)
target_include_directories(colorer_lib PUBLIC
    "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>"
    "$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>"
    "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>"
)

set_target_properties(colorer_lib PROPERTIES
    CXX_STANDARD 17
    CXX_STANDARD_REQUIRED YES
    CXX_EXTENSIONS YES
)

target_link_libraries(colorer_lib
        PUBLIC LibXml2::LibXml2
)

if(COLORER_USE_ICU_STRINGS)
  target_link_libraries(colorer_lib
      PUBLIC ICU::uc ICU::data
  )
  if (APPLE)
    target_include_directories(colorer_lib PUBLIC
         "$<BUILD_INTERFACE:/opt/homebrew/include>"
    )
  endif ()
endif()

if(COLORER_USE_ZIPINPUTSOURCE)
  if(COLORER_USE_VCPKG)
    target_link_libraries(colorer_lib PUBLIC unofficial::minizip::minizip)
  else()
    target_link_libraries(colorer_lib PUBLIC minizip::minizip)
  endif()
endif()

if(CMAKE_COMPILER_IS_GNUCXX AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 9)
  target_link_libraries(colorer_lib PUBLIC stdc++fs)
endif()

if(${CMAKE_BUILD_TYPE} MATCHES Debug)
  target_compile_options(colorer_lib PRIVATE $<$<COMPILE_LANGUAGE:CXX>:${MAIN_FLAGS_CXX_DEBUG}>)
else()
  target_compile_options(colorer_lib PRIVATE $<$<COMPILE_LANGUAGE:CXX>:${MAIN_FLAGS_CXX_RELEASE}>)
endif()

set_target_properties(colorer_lib PROPERTIES
    OUTPUT_NAME "colorer"
    VERSION ${COLORER_VERSION}
    SOVERSION ${COLORER_VERSION_MAJOR}
    DEBUG_POSTFIX "d"
)

=== debian/changelog ===
far2l (2.6.4~beta+ds-2) unstable; urgency=medium

  * d/control: drop unnecessary build-depends libgnutls28-dev, python3-debugpy,
    libxerces-c-dev, python3-pcpp, python3-venv, libffi-dev, libspdlog-dev,
    gawk.

 -- Alex Myczko <tar@debian.org>  Wed, 04 Dec 2024 09:46:53 +0000

far2l (2.6.4~beta+ds-1) unstable; urgency=medium

  * New upstream version. (Closes: #1084131)

 -- Alex Myczko <tar@debian.org>  Wed, 20 Nov 2024 10:26:02 +0000

far2l (2.6.3~beta+ds-5) unstable; urgency=medium

  * d/control: add python3-debugpy, python3-pcpp and
    python3-cffi to build-depends.

 -- Alex Myczko <tar@debian.org>  Tue, 01 Oct 2024 10:00:10 +0000

far2l (2.6.3~beta+ds-4) unstable; urgency=medium

  * d/control:
    - add libffi-dev to build-depends.
    - change Recommends to Suggests.
  * d/clean: added.

 -- Alex Myczko <tar@debian.org>  Mon, 30 Sep 2024 06:23:06 +0000

far2l (2.6.3~beta+ds-3) unstable; urgency=medium

  * Less split.

 -- Alex Myczko <tar@debian.org>  Thu, 29 Aug 2024 20:00:43 +0000

far2l (2.6.3~beta+ds-2) unstable; urgency=medium

  * Split the package into multiple binaries. Thanks for the pull
    request, Maksym Komar.
  * d/control: add more build-depends.

 -- Alex Myczko <tar@debian.org>  Sun, 11 Aug 2024 20:32:32 +0000

=== debian/control ===
Source: far2l
Section: utils
Priority: optional
Maintainer: Alex Myczko <tar@debian.org>
Build-Depends: debhelper-compat (= 13),
 cmake,
 libsmbclient-dev,
 libneon27-dev,
 libnfs-dev,
 libssh-dev,
 libxi-dev,
 libuchardet-dev,
 libarchive-dev,
 libpcre2-dev,
 libssl-dev,
 libwxgtk3.2-dev,
 libx11-dev,
 libpython3-dev,
 python3-cffi,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debian/far2l
Vcs-Git: https://salsa.debian.org/debian/far2l.git
Homepage: https://github.com/elfmz/far2l

Package: far2l
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, far2l-data
Suggests: chafa, htop
Provides:
 far2l (= ${binary:Version})
Conflicts:
 far2l-wx
Description: Linux port of FAR v2
 This is a clone of FAR manager for Windows, similar, but more
 powerful than Norton Commander/Midnight Commander.
 .
 Plug-ins that are currently working:
  - NetRocks (SFTP/SCP/FTP/FTPS/SMB/NFS/WebDAV)
  - colorer
  - multiarc
  - tmppanel
  - align
  - autowrap
  - drawline
  - editcase
  - SimpleIndent

Package: far2l-wx
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, far2l-data
Suggests: chafa, htop
Provides:
 far2l (= ${binary:Version})
Conflicts:
 far2l
Description: Linux port of FAR v2 - with WX GTK GUI
 This is a clone of FAR manager for Windows, similar, but more
 powerful than Norton Commander/Midnight Commander.
 .
 Plug-ins that are currently working:
  - NetRocks (SFTP/SCP/FTP/FTPS/SMB/NFS/WebDAV)
  - colorer
  - multiarc
  - tmppanel
  - align
  - autowrap
  - drawline
  - editcase
  - SimpleIndent
  - python
 .
 This package contains a version of far2l compiled with a WX GTK GUI

Package: far2l-data
Architecture: all
Depends: ${misc:Depends}
Description: Linux port of FAR v2, data files
 This is a clone of FAR manager for Windows, similar, but more
 powerful than Norton Commander/Midnight Commander.
 .
 Plug-ins that are currently working:
  - NetRocks (SFTP/SCP/FTP/FTPS/SMB/NFS/WebDAV)
  - colorer
  - multiarc
  - tmppanel
  - align
  - autowrap
  - drawline
  - editcase
  - SimpleIndent
 .
 This package contains the data files needed to run far2l.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -Bdebian/build-far2l -- \
		-DUNRAR=NO -DPYTHON=yes -DUSEWX=yes -DTTYX=yes -DTTYXI=yes

override_dh_auto_build:
	dh_auto_build -Bdebian/build-far2l

override_dh_auto_clean:
	dh_auto_clean -Bdebian/build-far2l

override_dh_auto_install:
	dh_auto_install -Bdebian/build-far2l      \
		--destdir=debian/install-far2l     -X.la -X.pyc -X.pyo -X__pycache__

override_dh_install:
	# no -pfar2l becouse destination directory by default far2l
	# and we need also generate fa2l-data
	dh_install              --sourcedir=debian/install-far2l
	rm -rf debian/far2l/usr/lib/far2l/Plugins/python/plug/python     \
	       debian/far2l-wx/usr/lib/far2l/Plugins/python/plug/python

override_dh_installman:
	dh_installman --sourcedir=debian/install-far2l

###-DCMAKE_USE_OPENSSL=OFF
###-DOPENSSL_ROOT_DIR=/dev/null
